#include <pthread.h>
#include <stdio.h>
#include <unistd.h>

#define TRIALS 10000

int cpt = 0;
pthread_mutex_t m;

void *thread(void *args)
{
  pthread_mutex_lock(&m);
  
  for(int i=0;i<TRIALS;i++)
    cpt += 1;

  pthread_mutex_unlock(&m);
    
  return NULL;
}

int main(int argc, char **argv)
{
  pthread_t thread1, thread2;

  // start the threads
  pthread_create(&thread1, NULL, thread, NULL);
  pthread_create(&thread2, NULL, thread, NULL);
  // wait for threads to finish
  pthread_join(thread1,NULL);
  pthread_join(thread2,NULL);
  pthread_mutex_destroy(&m);
  
  // Show errors if problem
  if (cpt != (2*TRIALS))
    printf("ERROR! cpt=%d \n", cpt);
    
  return 0;
}
