#include <pthread.h>
#include <stdio.h>
#include <unistd.h>
#include <semaphore.h> // POSIX semaphores

#define TRIALS 10000

int cpt = 0;
sem_t sem;

void *thread(void *args)
{
  sem_wait(&sem);  

  for(int i=0;i<TRIALS;i++)
    cpt += 1;

  sem_post(&sem);
    
  return NULL;
}

int main(int argc, char **argv)
{
  pthread_t thread1, thread2;

  // 0: Shared only by threads of current process, 1: single thread at a time (a.k.a mutex)
  sem_init(&sem, 0, 1);
  // start the threads
  pthread_create(&thread1, NULL, thread, NULL);
  pthread_create(&thread2, NULL, thread, NULL);
  // wait for threads to finish
  pthread_join(thread1,NULL);
  pthread_join(thread2,NULL);
  
  // Show errors if problem
  if (cpt != (2*TRIALS))
    printf("ERROR! cpt=%d \n", cpt);
    
  return 0;
}

