#include <pthread.h>
#include <stdio.h>
#include <unistd.h>

#define TRIALS 1000000

int cpt = 0;
pthread_barrier_t barr;

void *thread(void *args)
{
  // Retrieve val:
  int val=*(int*)args;

  // Second thread breaks here
  if(val)
    pthread_barrier_wait(&barr);

  for(int i=0;i<TRIALS;i++)
    cpt += 1;

  // First one here
  if(!val)
    pthread_barrier_wait(&barr);

  return NULL;
}

int main(int argc, char **argv)
{
  pthread_t thread1, thread2, thread3;
  int val1=0, val2=1;
  
  // 2: number of threads that reach the barrier before releasing them
  pthread_barrier_init(&barr,NULL,2);
  
  // start the threads
  pthread_create(&thread1, NULL, thread, &val1);
  pthread_create(&thread2, NULL, thread, &val2);

  // wait for threads to finish
  pthread_join(thread1,NULL);
  pthread_join(thread2,NULL);

  pthread_barrier_destroy(&barr);
  
  // Show errors if problem
  if (cpt != (2*TRIALS))
    printf("ERROR! cpt=%d \n", cpt);
    
  return 0;
}


